#import "AppDelegate.h"
#import "SaleViewController.h"
#import "StatusViewController.h"
#include <Uniterm/Uniterm.h>

@implementation SaleViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [_usernameField setDelegate:self];
    [_passwordField setDelegate:self];
    [_amountField setDelegate:self];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(BOOL) textFieldShouldReturn:(UITextField *)textField {
    if (textField.returnKeyType == UIReturnKeyNext) {
        if (textField == _usernameField) {
            [_usernameField resignFirstResponder];
            [_passwordField becomeFirstResponder];
        } else if (textField == _passwordField) {
            [_passwordField resignFirstResponder];
            [_amountField becomeFirstResponder];
        }
    }
    if (textField.returnKeyType == UIReturnKeyGo && textField == _amountField)
        [self doSubmitPayment:self];

    return YES;
}

- (BOOL)shouldPerformSegueWithIdentifier:(NSString *)identifier sender:(id)sender {
    /* We don't want this segue to happen automatically from being linked in
     * the storyboard because if the alert popup stops the segue it produces
     * warnings and we don't know exactly what will happen because it appears
     * to be a race condition. Instead we prevent it from happening and run it
     * programmatically (this function will not be called) when necessary. */
    if ([identifier isEqualToString:@"pushResult"])
        return NO;
    return YES;
}

- (IBAction)doSubmitPayment:(id)sender {
    NSMutableDictionary *req = [NSMutableDictionary dictionary];

    [req setObject:@"txnrequest" forKey:@"u_action"];
    [req setObject:@"sale" forKey:@"action"];
    [req setObject:_amountField.text forKey:@"amount"];
    [req setObject:@"1" forKey:@"u_id"];
    [req setObject:@"mfi:com.ingenico.easypayemv.spm-transaction" forKey:@"u_device"];
    //[req setObject:@"ip:10.200.10.184:12000" forKey:@"u_device"];
    [req setObject:@"ingenico_rba" forKey:@"u_devicetype"];
    [req setObject:_usernameField.text forKey:@"username"];
    [req setObject:_passwordField.text forKey:@"password"];
    
    /* Create the view and display it */
    StatusViewController *svc = [self.storyboard instantiateViewControllerWithIdentifier:@"statusScene"];

    svc.requestKVS = req;
    
    svc.navigationItem.leftBarButtonItem = nil;
    svc.navigationItem.hidesBackButton = YES;
    
    [self.navigationController pushViewController:svc animated:NO];
}

- (IBAction)doChkPwd:(id)sender {
    NSMutableDictionary *req = [NSMutableDictionary dictionary];

    [req setObject:@"passthrough" forKey:@"u_action"];
    [req setObject:@"chkpwd" forKey:@"action"];

    [req setObject:_usernameField.text forKey:@"username"];
    [req setObject:_passwordField.text forKey:@"password"];
    
    /* Create the view and display it */
    StatusViewController *svc = [self.storyboard instantiateViewControllerWithIdentifier:@"statusScene"];

    svc.requestKVS = req;
    
    svc.navigationItem.leftBarButtonItem = nil;
    svc.navigationItem.hidesBackButton = YES;
    
    [self.navigationController pushViewController:svc animated:NO];
}

- (IBAction)doChangeServer:(id)sender {
    NSMutableDictionary *req = [NSMutableDictionary dictionary];

    [req setObject:_serverField.text forKey:@"payment_server/host"];
    [req setObject:_portField.text forKey:@"payment_server/port"];

    BOOL ret = uniterm_modify_config(req);
    
    UIAlertController* alert = [UIAlertController alertControllerWithTitle:@"Modify Config"
                                                                   message:ret?@"Sucess":@"Failed"
                                   preferredStyle:UIAlertControllerStyleAlert];
     
    UIAlertAction* defaultAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault
       handler:^(UIAlertAction * action) {}];
     
    [alert addAction:defaultAction];
    [self presentViewController:alert animated:YES completion:nil];

}

- (IBAction)doVersion:(id)sender {
    NSMutableDictionary *req = [NSMutableDictionary dictionary];

    [req setObject:@"version" forKey:@"u_action"];
    
    [req setObject:_usernameField.text forKey:@"username"];
    [req setObject:_passwordField.text forKey:@"password"];
    
    /* Create the view and display it */
    StatusViewController *svc = [self.storyboard instantiateViewControllerWithIdentifier:@"statusScene"];

    svc.requestKVS = req;
    
    svc.navigationItem.leftBarButtonItem = nil;
    svc.navigationItem.hidesBackButton = YES;
    
    [self.navigationController pushViewController:svc animated:NO];
}


@end
